Loading...
Searching...
No Matches
Opm::VFPInjProperties< Scalar > Class Template Reference

## Public Member Functions

void | addTable (const VFPInjTable &new_table)
| Takes no ownership of data.
template<class EvalWell>
EvalWell | bhp (const int table_id, const EvalWell &aqua, const EvalWell &liquid, const EvalWell &vapour, const Scalar thp) const
| Linear interpolation of bhp as a function of the input parameters given as Evaluation Each entry corresponds typically to one well.
const VFPInjTable & | getTable (const int table_id) const
| Returns the table associated with the ID, or throws an exception if the table does not exist.
bool | hasTable (const int table_id) const
| Check whether there is table associated with ID.
bool | empty () const
| Returns true if no vfp tables are in the current map.
Scalar | bhp (const int table_id, const Scalar aqua, const Scalar liquid, const Scalar vapour, const Scalar thp) const
| Linear interpolation of bhp as a function of the input parameters.
Scalar | thp (const int table_id, const Scalar aqua, const Scalar liquid, const Scalar vapour, const Scalar bhp) const
| Linear interpolation of thp as a function of the input parameters.

## Protected Attributes

std::map< int, std::reference_wrapper< const VFPInjTable > > | m_tables

## Member Function Documentation

## bhp() [1/2]

template<class Scalar>
template<class EvalWell>

EvalWell Opm::VFPInjProperties< Scalar >::bhp | ( | const int | table_id,
|  | const EvalWell & | aqua,
|  | const EvalWell & | liquid,
|  | const EvalWell & | vapour,
|  | const Scalar | thp ) const

Linear interpolation of bhp as a function of the input parameters given as Evaluation Each entry corresponds typically to one well.

Parameters

  table_id | Table number to use. A negative entry (e.g., -1) will indicate that no table is used, and the corresponding BHP will be calculated as a constant -1e100.
  aqua | Water phase
  liquid | Oil phase
  vapour | Gas phase
  thp | Tubing head pressure

Returns
  The bottom hole pressure, interpolated/extrapolated linearly using the above parameters from the values in the input table, for each entry in the input ADB objects.

## bhp() [2/2]

template<class Scalar>

Scalar Opm::VFPInjProperties< Scalar >::bhp | ( | const int | table_id,
|  | const Scalar | aqua,
|  | const Scalar | liquid,
|  | const Scalar | vapour,
|  | const Scalar | thp ) const

Linear interpolation of bhp as a function of the input parameters.

Parameters

  table_id | Table number to use
  aqua | Water phase
  liquid | Oil phase
  vapour | Gas phase
  thp | Tubing head pressure

Returns
  The bottom hole pressure, interpolated/extrapolated linearly using the above parameters from the values in the input table.

## thp()

template<class Scalar>

Scalar Opm::VFPInjProperties< Scalar >::thp | ( | const int | table_id,
|  | const Scalar | aqua,
|  | const Scalar | liquid,
|  | const Scalar | vapour,
|  | const Scalar | bhp ) const

Linear interpolation of thp as a function of the input parameters.

Parameters

  table_id | Table number to use
  aqua | Water phase
  liquid | Oil phase
  vapour | Gas phase
  bhp | Bottom hole pressure

Returns
  The tubing hole pressure, interpolated/extrapolated linearly using the above parameters from the values in the input table.

Find the function bhp_array(thp) by creating a 1D view of the data by interpolating for every value of thp. This might be somewhat expensive, but let us assome that nthp is small

The documentation for this class was generated from the following files:

- opm/simulators/wells/VFPInjProperties.hpp
- opm/simulators/wells/VFPInjProperties.cpp